
#include "header.h"


unsigned char i = 0;
unsigned char ticks[TICKS];

extern unsigned int humidWord, tempWord;
char checkSum;


void fSendRequest(){
  DATA_TRIS.DATA_PIN = OUTPUT;
  DATA_PORT.DATA_PIN = HIGH;
  Delay_ms(30);
  DATA_PORT.DATA_PIN = LOW;
  Delay_ms(2);
  DATA_PORT.DATA_PIN = HIGH;
  Delay_us(40);
  DATA_TRIS.DATA_PIN = INPUT;
  Delay_us(30);
  while(DATA_PORT.DATA_PIN == LOW);
  Delay_us(10);
  while(DATA_PORT.DATA_PIN == HIGH);
  Delay_us(10);

  for (i = 0; i < TICKS; i++){
    Delay_us(3);
    while(DATA_PORT.DATA_PIN == LOW);
    ticks[i] = 0;

    do{
      ticks[i]++;
      Delay_1us();
      if(ticks[i] >= 250) break;
      } while(DATA_PORT.DATA_PIN == HIGH);
  }

  DATA_TRIS.DATA_PIN = OUTPUT;
  DATA_PORT.DATA_PIN = HIGH;

  /* parse data from sensor */
  humidWord = 0;
  tempWord = 0;
  checkSum = 0;
  
  for(i = 0; i < 16; i++){
    if(ticks[i] > TICK_EDGE) humidWord |= (1 << (15 - i));
  }

  for(i = 0; i < 16; i++){
    if(ticks[i + 16] > TICK_EDGE) tempWord |= (1 << (15 - i));
  }
    
  for(i = 0; i < 8; i++){
    if(ticks[i + 32] > TICK_EDGE) checkSum |= (1 << (7 - i));
  }
}



unsigned char *fConvTempToStr(int actValue){
   float actTemp;
   static unsigned char returnString[15];
   
   if(actValue & 0x8000){   // negative temp
      actValue &= 0x7FFF;
      actTemp = (float) actValue / 10.0 * -1.0;
    }
    else{
      actTemp = (float) actValue / 10.0;
    }
    
   FloatToStr(actTemp, returnString);

   for(i = 0; i < 15; i++){
      if(returnString[i] == 46){    // find comma
         returnString[i + 2] = 0;   // NULL termination
         break;
      }
      else if(returnString[i] < 45){
         returnString[i] = 46;      // ASCII dot
         returnString[i + 1] = 48;  // ASCII zero
         returnString[i + 2] = 0;   // NULL termination
         break;
      }
   }
   
   return returnString;
}
 
 
 
 unsigned char *fConvHumToStr(int actValue){
   static unsigned char returnString[15];

   FloatToStr(((float)(actValue & 0x7FFF) / 10.0), returnString);

   for(i = 0; i < 15; i++){
      if(returnString[i] == 46){    // find comma
         returnString[i + 2] = 0;   // NULL termination
         break;
      }
      else if(returnString[i] < 45){
         returnString[i] = 46;      // ASCII dot
         returnString[i + 1] = 48;  // ASCII zero
         returnString[i + 2] = 0;   // NULL termination
         break;
      }
   }
   
   return returnString;
 }
 
 
 unsigned char fCheckSumTest(){
   unsigned char checkS1, checkS2, checkS3, checkS4;
   
   checkS1 = humidWord >> 8;
   checkS2 = humidWord & 0xFF;
   checkS3 = tempWord >> 8;
   checkS4 = tempWord & 0xFF;

   if(checkSum == ((checkS1 + checkS2 + checkS3 + checkS4) & 0xFF)){
      return 1;
   }
   else{
      return 2;
   }
 }