

#include "header.h"


extern unsigned int humidWord, tempWord, humidOld, tempOld;
extern unsigned int humidMin, humidMax, tempMin, tempMax;


// set delay how often to update data
// minimum is 1 sec acc. to AM2302 datasheet
void fDelay(){  
  unsigned char k;
  
  for(k = 0; k < 10; k++){
    Delay_ms(1000);
  }
}


void fInit(){
  /* configure MCU */
  ANSEL       = 0;    // configure AN pins as digital I/O
  ANSELH      = 0;
  TRISA       = 0xFF; // set PORTA to input
  TRISC       = 0;
  C1ON_bit    = 0;    // disable comparators
  C2ON_bit    = 0;
  INTCON.PEIE = 0;    // peripheral interrupt
  INTCON.RBIE = 0;    // RB interrupt disable
  INTCON      = 0;
  IOCB        = 0;    // disable interrupt on change
  IRCF0_bit   = 1;    // config internal osc to 8MHz
  IRCF1_bit   = 1;
  IRCF2_bit   = 1;
  SCS_bit     = 1;

  /* prepare GLCD */
  Delay_ms(500);
  Glcd_Init();
  Glcd_Fill(0);
  Delay_ms(500);
  DATA_TRIS.DATA_PIN = OUTPUT;
  DATA_PORT.DATA_PIN = HIGH;
  Glcd_Set_Font_Adv(&Arial_Narrow12x12,1,0); // 
  Glcd_Write_Text_Adv("", 66,0);
  Glcd_Set_Font_Adv(&Arial_Narrow22x31,1,0); // C
  Glcd_Write_Text_Adv("C", 78,0);
  Glcd_Set_Font_Adv(&Arial_Narrow27x31,1,0); // %
  Glcd_Write_Text_Adv("%", 72,33);
  Delay_ms(500);
  Glcd_Set_Font_Adv(&Arial_Narrow18x31, 1, 0);

  /* request first data from sensor and write to GLCD */
  fSendRequest();

  /* set first value as min and max */
  humidMin = humidMax = humidOld = humidWord;
  tempMin  = tempMax = tempOld = tempWord;

  Glcd_Write_Text(fConvTempToStr(tempMax), 105,0,1);
  Glcd_Write_Text(fConvTempToStr(tempMin), 105,2,1);
  Glcd_Write_Text_Adv(fConvTempToStr(tempMin), 0, 0);
  Glcd_Write_Text(fConvHumToStr(humidMax), 105,5,1);
  Glcd_Write_Text(fConvHumToStr(humidMin), 105,7,1);
  Glcd_Write_Text_Adv(fConvHumToStr(humidMin), 0, 33);
  fDelay();
}